#ifndef StatistikTabelle_H
#define StatistikTabelle_H

#include <Tabelle.h>
#include <AuswahlBox.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikTabelle
{
private:
	Schrift *schrift;
	Array< SSDSpieler* > *ssdgs;
	Array< SSDTeam* > *ssdgt;
	AuswahlBox *stAuswahl;
	AuswahlBox *sortAuswahlGS;
	AuswahlBox *sortAuswahlGT;
	AuswahlBox *sortRichtungGS;
	AuswahlBox *sortRichtungGT;
	ObjTabelle *gesamtSpieler;
	ObjTabelle *gesamtTeam;
	bool teamS;
	bool rend;
	int ref;
	// privat
	void tabelleLehren( ObjTabelle *zT, bool berschrift );
	void tabelleFllen( ObjTabelle *zT );

public:
	// Konstruktor
	StatistikTabelle( Array< SSDSpieler* > *ssdgs, Array< SSDTeam* > *ssdgt, Schrift *zSchrift, Bildschirm *zScreen, bool historie = 0 );
	// Destruktor
	~StatistikTabelle();
	// nicht constant
	void doMausEreignis( MausEreignis &me );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// Reference Counting
	StatistikTabelle *getThis();
	StatistikTabelle *release();
};

#endif